#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "yse.h"
#include "yse_background.h"

#define YSE_BACKGROUND_FILTER_SIZE			256
#define YSE_BACKGROUND_FILTER_SIZE_2		(YSE_BACKGROUND_FILTER_SIZE / 2)

int yse_background_compare_gain(const void *gain, const void *gain0)
{
	return (*(float *)gain - *(float *)gain0);
}

// ߽ɿ ׶ Ȧ带 ϴ  ƾ
float yse_background_estimate(yse_field_t *field, float *rms)
{
	int x, y, dx, dy, n;
	float gain[YSE_BACKGROUND_FILTER_SIZE * YSE_BACKGROUND_FILTER_SIZE];
	float sum, ssum;
	float mean, mode, median, sigma, sigma0;
	float background, threshold;
	int i, j, k;

	n = 0;
	sum = ssum = 0.;
	for (dy = -YSE_BACKGROUND_FILTER_SIZE_2; dy <= YSE_BACKGROUND_FILTER_SIZE_2; dy++)
	{
		y = dy + field->height / 2;
		if (y < 0 || y >= field->height)
			continue;
		for (dx = YSE_BACKGROUND_FILTER_SIZE_2; dx <= YSE_BACKGROUND_FILTER_SIZE_2; dx++)
		{
			x = dx + field->width / 2;
			if (x < 0 || x >= field->width)
				continue;
			gain[n] = field->data[y][x];
			sum += gain[n];
			ssum += gain[n] * gain[n];
			n++;
		}
	}
	
	qsort(gain, n, sizeof (float), yse_background_compare_gain);
	
	sigma0 = -1.;
	for (i = 0; ; i++)
	{
		mean = sum / n;
		median = gain[n / 2];
		mode = 2.5 * median - 1.5 * mean;
		sigma = (sigma = ssum / n - mean * mean) > 0.0 ? sqrt(sigma) : 0.0;

		if (i > 0 && fabs((sigma - sigma0) / sigma0) < 0.2)
		{
			background = mean;
			threshold = sigma * 3.;
			break;
		}

		for (j = n - 1; j >= 0; j--)
			if (gain[j] <= median + 3. * sigma)
				break;

		if (++j == n)
		{
			mode = 2.5 * median - 1.5 * mean;
			background = mode;
			threshold = sigma * 3.;
			break;
		}

		for (k = j; k < n; k++)
		{
			sum -= gain[k];
			ssum -= gain[k] * gain[k];
		}

		sigma0 = sigma;
		n = j;
	}
	
	rms[0] = mean;
	rms[1] = sigma;
	//threshold += (field->FWHM - 2.) * sigma;
	
	return background + threshold;
}
