#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

//#include <starfind.h>

#include "yse.h"
#include "yse_line_list.h"
#include "yse_star_list.h"
#include "yse_line.h"


//if too many streaks are detected, then remove short lines
int yse_delete_short_line(const char *filename, yse_field_t *field)
{
	char EXEC[256];
	char EXEC2[256];
	char buf[100];
	
	int i, j;
	int index = 0;
	int index2 = 0;
	//No starts at 1
	int No;
	int x_min;
	int x_max;
	int y_min;
	int y_max;
	float slope;
	int NSTAR;
	float dev;
	float flatness;
	float length;
	
	sprintf(EXEC, "%s.out.txt", filename);
	sprintf(EXEC2, "%s.out.txt2", filename);
	FILE *f = fopen(EXEC, "r");
	FILE *f2 = fopen(EXEC2, "w");
	
	fprintf(f, "#No xmin ymin xmax ymax   slope  NSTAR dev flat length\n");
	while(fgets(buf, 100, f))
	{
		if(buf[0] != '#')
		{
			sscanf(buf, "%d %d %d %d %d %f %d %f %f %f", &No, &x_min, &y_min,
			&x_max, &y_max, &slope, &NSTAR, &dev, &flatness, &length);
			
			if(length > field->FWHM * 2)
			{
				index2++;
				fprintf(f2, "%3d %4d %4d %4d %4d %f %4d %f  %f  %f\n", index2, x_min, y_min, x_max,
				 y_max, slope, NSTAR, dev, flatness, length);
			}
		
			index++;
		}
	}
	
	fclose(f);
	fclose(f2);
	
	unlink(EXEC);
	rename(EXEC2, EXEC);
	
	return index2;
}

//analyzing result txt, correlation check
int yse_find_correlation(const char *filename, yse_field_t *field, float min_length_streak)
{
	char EXEC[256];
	char buf[80];
	
	int i, j;
	int index = 0;
	//No starts at 1
	int No[MAX_STREAK_NUM_BEF_COR];
	int x_min[MAX_STREAK_NUM_BEF_COR];
	int x_max[MAX_STREAK_NUM_BEF_COR];
	int y_min[MAX_STREAK_NUM_BEF_COR];
	int y_max[MAX_STREAK_NUM_BEF_COR];
	float slope[MAX_STREAK_NUM_BEF_COR];
	int NSTAR[MAX_STREAK_NUM_BEF_COR];
	float dev[MAX_STREAK_NUM_BEF_COR];
	float flatness[MAX_STREAK_NUM_BEF_COR];
	float length[MAX_STREAK_NUM_BEF_COR];
	//No of streak which has correlation with current one
	int correl_no[MAX_STREAK_NUM_BEF_COR];
	
	float center_x1 = 0., center_y1 = 0., center_x2 = 0., center_y2 = 0.;
	float dist_1 = 0., dist_2 = 0., dist_3 = 0.;
	float dev_1 = 0., dev_2 = 0.;
	float dummy1, dummy2, dummy3;
	float deg_to_rad = 3.141592 / 180.;
	
	int go_on = 0;
	
	sprintf(EXEC, "%s.out.txt", filename);
	FILE *f = fopen(EXEC, "r");
	
	while(fgets(buf, 80, f))
	{
		if(buf[0] != '#')
		{
			sscanf(buf, "%d %d %d %d %d %f %d %f %f %f", &No[index], &x_min[index], &y_min[index],
			&x_max[index], &y_max[index], &slope[index], &NSTAR[index], &dev[index], &flatness[index], &length[index]);

			index++;
		}
	}
	
	fclose(f);
	
	//setting correlation no -1 : not correlated
	for(i = 0; i < MAX_STREAK_NUM_BEF_COR; i++)
		correl_no[i] = -1;
	
	for(i = 0; i < index; i++)
	{
		for(j = i + 1; j < index; j++)
		{
			
			center_x1 = (x_min[i] + x_max[i]) / 2.;
			center_y1 = (y_min[i] + y_max[i]) / 2.;
			center_x2 = (x_min[j] + x_max[j]) / 2.;
			center_y2 = (y_min[j] + y_max[j]) / 2.;
			
			dist_1 = abs(center_x1 - center_x2);
			dist_2 = center_x1 - x_min[i];
			dist_3 = center_x2 - x_min[j];
			
			//printf("x %f %f %f\n", dist_1, dist_2, dist_3);
			
			if(dist_1 <= (dist_2 + dist_3))
			{
				dist_1 = abs(center_y1 - center_y2);
				dist_2 = center_y1 - y_min[i];
				dist_3 = center_y2 - y_min[j];
				
				//printf("y %f %f %f\n", dist_1, dist_2, dist_3);
				if(dist_1 <= (dist_2 + dist_3))
				{
					correl_no[i] = No[j];
					break;
				}
			}
			
			if(min_length_streak != 0.)
			{
				dummy1 = atan(deg_to_rad * slope[i]);
				dummy2 = atan(deg_to_rad * slope[j]);
				if(dummy1 > dummy2)
				{
					dummy3 = dummy1;
					dummy1 = dummy2;
					dummy2 = dummy3;
				}
				
				dummy3 = dummy2 - dummy1;
				
				//if((slope[i] - slope[j]) < 0.1 && (slope[i] - slope[j]) > -0.1)
				if(dummy3 < 5.)
					go_on = 1;
				else
					go_on = 0;
			}
			else
				go_on = 1;
			
			//slope check
			if(go_on == 1)
			{
				printf("slope check ok\n");
				go_on = 0;
				//find shortest distance between two streaks
				dist_1 = sqrt((x_min[i] - x_min[j]) * (x_min[i] - x_min[j]) + 
					(y_min[i] - y_min[j]) * (y_min[i] - y_min[j]));
					
				dist_2 = sqrt((x_max[i] - x_max[j]) * (x_max[i] - x_max[j]) + 
					(y_max[i] - y_max[j]) * (y_max[i] - y_max[j]));
				
				if(dist_1 > dist_2)
					dist_1 = dist_2;
					
				dist_2 = sqrt((x_min[i] - x_max[j]) * (x_min[i] - x_max[j]) + 
					(y_min[i] - y_max[j]) * (y_min[i] - y_max[j]));
					
				if(dist_1 > dist_2)
					dist_1 = dist_2;
				
				dist_2 = sqrt((x_max[i] - x_min[j]) * (x_max[i] - x_min[j]) + 
					(y_max[i] - y_min[j]) * (y_max[i] - y_min[j]));
					
				if(dist_1 > dist_2)
					dist_1 = dist_2;
				//printf("%f %f\n", dist_1, field->FWHM * 10.);
				//distance check
				if(min_length_streak != 0.)
				{
					//printf("%f %f\n", dist_1, length[i] * 10.);
					//if(dist_1 < field->FWHM * 10.)
					//if(dist_1 < 300.)
					if(dist_1 < length[i] * 2 || dist_1 < length[j] * 2)
						go_on = 1;
					else
						go_on = 0;
				}
				else
				{
					if(dist_1 < (field->FWHM * 10.))
						go_on = 1;
				}
				
				//if(dist_1 < field->FWHM * 10)
				if(go_on == 1)
				{
					go_on = 0;
					if(dev[i] > dev[j])
					{
						dev_1 = dev[i];
						dev_2 = dev[j];
					}
					else
					{
						dev_1 = dev[j];
						dev_2 = dev[i];
					}
					
					if(min_length_streak != 0.)
					{
						if(dev_1 / dev_2 < 3.)
							go_on = 1;
						else
							go_on = 0;
					}
					else
						go_on = 1;
					//dev check
					if(go_on == 1)
					{
						go_on = 0;
						//find distance from i line to j point
						dist_1 = abs(slope[i] * x_min[j] - y_min[j] + (y_min[i] - slope[i] * x_min[i]))
						 / sqrt(slope[i] * slope[i] + 1.);
						dist_2 = abs(slope[i] * x_max[j] - y_max[j] + (y_min[i] - slope[i] * x_min[i]))
						 / sqrt(slope[i] * slope[i] + 1.);
						
						if(dist_1 > dist_2)
							dist_1 = dist_2;
							
						//distance check -- ignore
						//if(dist_1 < field->FWHM * 10)
						{
							correl_no[i] = No[j];
							break;
						}
					}
				}
			}
		}
	}
	
	f = fopen(EXEC, "w");
	
	fprintf(f, "#No xmin ymin xmax ymax   slope   NSTAR dev flat length  correlation\n");
	
	for(i = 0; i < index; i++)
	{
		fprintf(f, "%3d %4d %4d %4d %4d %f %4d %f  %f  %f %d\n", No[i], x_min[i], y_min[i], x_max[i], y_max[i], slope[i], NSTAR[i], dev[i], flatness[i], length[i], correl_no[i]);
	}
	
	fclose(f);
	
	return 0;
}

//make text result for jpeg from correlated result txt file
int yse_make_text_for_jpeg(const char *filename, yse_field_t *field, float min_length_streak, int *num_corr)
{
	char EXEC[256];
	char buf[80];
	
	int i, j;
	int swap;
	int index = 0;
	int No[MAX_STREAK_NUM_BEF_COR];
	int x_min[MAX_STREAK_NUM_BEF_COR];
	int x_max[MAX_STREAK_NUM_BEF_COR];
	int y_min[MAX_STREAK_NUM_BEF_COR];
	int y_max[MAX_STREAK_NUM_BEF_COR];
	float slope[MAX_STREAK_NUM_BEF_COR];
	int NSTAR[MAX_STREAK_NUM_BEF_COR];
	float dev[MAX_STREAK_NUM_BEF_COR];
	float flatness[MAX_STREAK_NUM_BEF_COR];
	float length[MAX_STREAK_NUM_BEF_COR];
	//No of streak which has correlation with current one
	int correl_no[MAX_STREAK_NUM_BEF_COR];
	
	int x_border_max, x_border_min;
	int y_border_max, y_border_min;
	int x_streak_max, x_streak_min;
	int y_streak_max, y_streak_min;
	int border_dummy;
	
	int checked;
	int line_index = 0;
	int num_correlated = 0;
	
	int tot_num_star = 0;
	float total_length = 0.;
	float avg_slope = 0.;
	float avg_dev = 0.;
	float avg_flatness = 0.;
	
	int num_longer_than_MLS = 0;
	int write_file = 1;
	int num_cor_streak = 0;
	
	sprintf(EXEC, "%s.out.txt", filename);
	FILE *f = fopen(EXEC, "r");
	
	while(fgets(buf, 80, f))
	{
		if(buf[0] != '#')
		{
			sscanf(buf, "%d %d %d %d %d %f %d %f %f %f %d", &No[index], &x_min[index], &y_min[index],
			&x_max[index], &y_max[index], &slope[index], &NSTAR[index], &dev[index], &flatness[index], &length[index], &correl_no[index]);

			index++;
		}
	}
	
	fclose(f);
	
	sprintf(EXEC, "%s.dat", filename);
	f = fopen(EXEC, "w");
	
	for(i = 0; i < index; i++)
	{
		//printf("#result of %dth line are processed...\n", i);
		//if checked or end element, skip it
		j = i;
		checked = 0;
		avg_slope = slope[i];
		avg_dev = dev[i];
		avg_flatness = flatness[i];
		total_length = length[i];
		tot_num_star = NSTAR[i];
		num_correlated = 1;
		
		//printf("%d:%f:%f:%d-", i, total_length, avg_flatness, correl_no[i]);

		x_border_min = x_min[i];
		y_border_min = y_min[i];
		x_border_max = x_max[i];
		y_border_max = y_max[i];
		
		if(!(correl_no[i] == -2 || correl_no[i] == -1))
		{
			while(1)
			{
				checked = 1;
				if(j == -3)
					break;
				
				if(correl_no[j] != -1)
				{
					swap = j;
					j = correl_no[j] - 1;
					//set element checked
					correl_no[swap] = -2;
					avg_slope += slope[j];
					avg_dev += dev[j];
					avg_flatness += flatness[j];
					total_length += length[j];
					tot_num_star += NSTAR[j];
					num_correlated++;
					
					if(x_border_min > x_min[j])
					{
						x_border_min = x_min[j];
					}
					if(y_border_min > y_min[j])
					{
						y_border_min = y_min[j];
					}
					if(x_border_max < x_max[j])
					{
						x_border_max = x_max[j];
					}
					if(y_border_max < y_max[j])
					{
						y_border_max = y_max[j];
					}
				}
				else
				{
					//set element checked
					correl_no[j] = -2;
					break;
				}
			}
		}
		
		if(j != -3)
		{
			if((checked == 0 && correl_no[i] == -1) || checked == 1)
			{
				avg_slope = avg_slope / num_correlated;
				avg_dev = avg_dev / num_correlated;
				avg_flatness = avg_flatness / num_correlated;
				
				line_index++;
				//x_border_min = x_min[i];
				//y_border_min = y_min[i];
				//x_border_max = x_max[j];
				//y_border_max = y_max[j];
				
				if(x_border_min > x_border_max)
				{
					border_dummy = x_border_min;
					x_border_min = x_border_max;
					x_border_max = border_dummy;
				}
				
				if(y_border_min > y_border_max)
				{
					border_dummy = y_border_min;
					y_border_min = y_border_max;
					y_border_max = border_dummy;
				}
				
				x_streak_max = x_border_max;
				x_streak_min = x_border_min;
				y_streak_max = y_border_max;
				y_streak_min = y_border_min;
				
				x_border_min = x_border_min - 128;
				y_border_min = y_border_min - 128;
				x_border_max = x_border_max + 128;
				y_border_max = y_border_max + 128;
				
				if(x_border_min < 0) x_border_min = 1;
				if(y_border_min < 0) y_border_min = 1;
				if(x_border_max > field->width) x_border_max = field->width;
				if(y_border_max > field->height) y_border_max = field->height;
				
				x_streak_max = x_streak_max - x_streak_min;
				y_streak_max = y_streak_max - y_streak_min;
				x_streak_min = x_streak_min - x_border_min;
				y_streak_min = y_streak_min - y_border_min;
				
				x_streak_max = x_streak_min + x_streak_max + 20;
				y_streak_max = y_streak_min + y_streak_max + 20;
				x_streak_min = x_streak_min - 20;
				y_streak_min = y_streak_min - 20;
				
				if(x_streak_min < 0) x_streak_min = 1;
				if(y_streak_min < 0) y_streak_min = 1;
				if(x_streak_max > field->width) x_streak_max = field->width;
				if(y_streak_max > field->height) y_streak_max = field->height;
				
				if(min_length_streak != 0.)
				{
					if(total_length >= min_length_streak)
					{
						num_longer_than_MLS++;
						write_file = 1;
					}
					else
						write_file = 0;
				}
				else
				{
					write_file = 1;
				}
				
				if(write_file == 1)
				{
					num_cor_streak++;
					fprintf(f, "%3d %4d %4d %4d %4d %4.2f %5d %3.2f %3.2f %5.2f %3d %3d %3d %3d\n",
					 line_index, x_border_min, y_border_min, x_border_max, y_border_max,
					  avg_slope, tot_num_star, avg_dev, avg_flatness, total_length, 
					  x_streak_min, y_streak_min, x_streak_max, y_streak_max);
				}
				
				/*
				sprintf(EXEC, "%s %s[%d:%d,%d:%d] %s.out.fits", IMCOPY_EXEC, filename
				, x_border_min, x_border_max, y_border_min, y_border_max, filename);
				system(EXEC);
				
				sprintf(EXEC, "%s -fits %s.out.fits -jpeg %s-%d.jpeg -max %f -min %f", FITS2JPEG_EXEC, filename, filename
				, i, rms[0] + rms[1] * 10., rms[0] - rms[1] * 20.);
				system(EXEC);
				
				sprintf(EXEC, "%s.out.fits", filename);
				unlink(EXEC);
				*/
			}
		}
	}
	
	fclose(f);
	
	num_corr[0] = num_cor_streak;
	return num_longer_than_MLS;
}

//make jpeg output from correlated result txt file
int yse_make_jpeg(const char *filename, yse_field_t *field, float *rms)
{
	char EXEC[256];
	char buf[80];
	
	int i, j;
	int swap;
	int index = 0;
	int No[MAX_STREAK_NUM];
	int x_min[MAX_STREAK_NUM];
	int x_max[MAX_STREAK_NUM];
	int y_min[MAX_STREAK_NUM];
	int y_max[MAX_STREAK_NUM];
	float slope[MAX_STREAK_NUM];
	int NSTAR[MAX_STREAK_NUM];
	float dev[MAX_STREAK_NUM];
	float flatness[MAX_STREAK_NUM];
	float length[MAX_STREAK_NUM];
	
	//No of streak which has correlation with current one
	int correl_no[MAX_STREAK_NUM];
	
	int x_border_max, x_border_min;
	int y_border_max, y_border_min;
	int border_dummy;
	
	int checked;
	
	sprintf(EXEC, "%s.dat", filename);
	FILE *f = fopen(EXEC, "r");
	
	while(fgets(buf, 80, f))
	{
		if(buf[0] != '#')
		{
			sscanf(buf, "%d %d %d %d %d %f %d %f %f %d", &No[index], &x_min[index], &y_min[index],
			&x_max[index], &y_max[index], &slope[index], &NSTAR[index], &dev[index], &flatness[index], &length[index]);

			index++;
		}
	}
	
	fclose(f);
	
	for(i = 0; i < index; i++)
	{
		printf("#result of %dth line are processed...\n", i);
		//if checked or end element, skip it
		j = i;
		checked = 0;
		
		//if(j != -3)
		{
			//if((checked == 0 && correl_no[i] == -1) || checked == 1)
			{
				x_border_min = x_min[i] - 128;
				y_border_min = y_min[i] - 128;
				x_border_max = x_max[j] + 128;
				y_border_max = y_max[j] + 128;
				
				if(x_border_min < 0) x_border_min = 1;
				if(y_border_min < 0) y_border_min = 1;
				if(x_border_max > field->width) x_border_max = field->width;
				if(y_border_max > field->height) y_border_max = field->height;
				
				sprintf(EXEC, "%s %s[%d:%d,%d:%d] %s.out.fits", IMCOPY_EXEC, filename
				, x_border_min, x_border_max, y_border_min, y_border_max, filename);
				system(EXEC);
				
				sprintf(EXEC, "%s -fits %s.out.fits -jpeg %s-%d.jpeg -max %f -min %f", FITS2JPEG_EXEC, filename, filename
				, i, rms[0] + rms[1] * 5., rms[0] - rms[1] * 10.);
				system(EXEC);
				
				sprintf(EXEC, "%s.out.fits", filename);
				unlink(EXEC);
			}
		}
	}
	
	return 0;
}

//using sex data
int yse_num_sex_star(yse_line_list *list, yse_star_list *star, int x_border_min, int y_border_min, int x_border_max, int y_border_max)
{
	int numStar = 0;
	
	int d1 = 0, d2 = 0;
	int x_left = 0, x_right = 0;
	int y_up = 0, y_down = 0;
	
	yse_star_list *star_list;
	yse_line_list *line_list;
	//yse_star_print(star);
	//yse_star_print(star);
	for(star_list = star; star_list != NULL; star_list = star_list->next)
	{
		if(star_list->x > x_border_min && star_list->x < x_border_max
		&& star_list->y > y_border_min && star_list->y < y_border_max)
		{
			d1 = 0, d2 = 0;
			x_left = 0, x_right = 0;
			y_up = 0, y_down = 0;
			for(line_list = list; line_list != NULL; line_list = line_list->next)
			{
				if(star_list->y == line_list->y)
				{
					d1 = star_list->x - line_list->x;
					if(d1 < 0)
					{
						d2 = star_list->x - x_right;
						if(abs(d1) < abs(d2))
							x_right = line_list->x;
					}
					else
					{
						d2 = star_list->x - x_left;
						if(abs(d1) < abs(d2))
							x_left = line_list->x;
					}
				}
				
				if(star_list->x == line_list->x)
				{
					d1 = star_list->y - line_list->y;
					if(d1 < 0)
					{
						d2 = star_list->y - y_up;
						if(abs(d1) < abs(d2))
							y_up = line_list->y;
					}
					else
					{
						d2 = star_list->y - y_down;
						if(abs(d1) < abs(d2))
							y_down = line_list->y;
					}
				}
			}
			//printf("%d %d : %d %d %d %d\n", star_list->x, star_list->y, x_left, x_right, y_down, y_up);
			if((star_list->x - x_left) * (star_list->x - x_right) < 0 &&
			(star_list->y - y_up) * (star_list->y - y_down) < 0)
			{
				if(x_left != 0 && x_right != 0 && y_up != 0 && y_down != 0)
				{
					numStar++;
					//printf("%d %d\n", star_list->x, star_list->y);
				}
			}
		}
	}
	
	return numStar;
}

//using daophot
/*
int yse_num_star(yse_field_t *field, yse_line_list *list, float xf_min, float yf_min, float xf_max, float yf_max)
{
	int i, j;
	int numStar = 0;
	long naxes[2];
	float *array;
	long npixels;
	long x_min, x_max, y_min, y_max;
	long dummy;
	
	if(xf_min < xf_max)
	{
		x_min = xf_min;
		x_max = xf_max;
	}
	else
	{
		x_min = xf_max;
		x_max = xf_min;
	}
	
	if(yf_min < yf_max)
	{
		y_min = yf_min;
		y_max = yf_max;
	}
	else
	{
		y_min = yf_max;
		y_max = yf_min;
	}
	
	naxes[0] = x_max - x_min;
	naxes[1] = y_max - y_min;
	
	npixels = naxes[0] * naxes[1];
	array = (float *) calloc(npixels, sizeof(float));
	printf("#%ld %ld\n", naxes[0], naxes[1]);
	for(i = y_min; i < y_max; i++)
	{
		for(j = x_min; j < x_max; j++)
		{
			*(array + (i - y_min) * naxes[0] + (j - x_min)) = field->data[i][j];
			if(*(array + (i - y_min) * naxes[0] + (j - x_min)) > 313)
				printf("1");
			else
				printf("0");
		}
		//printf("\n");
	}
	
	dummy = naxes[0];
	naxes[0] = naxes[1];
	naxes[1] = dummy;
	
	//numStar = starfind(field->FWHM, array, naxes);
	//numStar = starfind(field->FWHM, field->data_buffer, naxes);
	
	free(array);
	
	return numStar;
}
*/

/*
//find peak value. range search from (x, y) center
void yse_find_peak_value(yse_field_t *field, int x, int y, int range, int *peakValue)
{
	int i, j;
	
	peakValue[0] = -1;
	peakValue[1] = -1;
	peakValue[2] = -1;
	
	for(j = y - range; j <= y + range; j++)
		for(i = x - range; i <= x + range; i++)
		{
			if((i < field->width && i > -1) && (j < field->height && j > -1))
				if(peakValue[2] < field->data[j][i])
				{	
					peakValue[0] = i;
					peakValue[1] = j;
					peakValue[2] = field->data[j][i];
				}
		}
}

//find peak line
void yse_peak_line(yse_field_t *field, yse_line_list *list, int sx, yse_line_list *line3, yse_line_list *peak_line)
{
	yse_line_list *line, *line2;
	
	int array_size = yse_line_length(list);
	int array_peak_line[array_size][2];
	int curX, curY, minX, minY, maxX, maxY;
	int xValue = 0, yValue = 0;
	int peakValue[3];
	int flag = 0;
	int addValue = 1;
	int i, j;
	
	array_size = 0;
	
	if (fabsf(sx) < 1.)
		flag = 1;
	else
		flag = 0;
	
	for (line = list; line != NULL; line = line->next)
	{
		curX = minX = maxX = line->x;
		curY = minY = maxY = line->y;
		addValue = 1;
		
		for (line2 = list; line2 != NULL; line2 = line2->next)
		{
			if(flag)
			{
				if(curX == line2->x)
				{
					if(minY > line2->y)
						minY = line2->y;
					if(maxY < line2->y)
						maxY = line2->y;
				}
			}
			else
			{
				if(yValue == line2->y)
				{
					if(minX > line2->x)
						minX = line2->x;
					if(maxX < line2->x)
						maxX = line2->x;
				}
			}
		}
		
		xValue = (minX + maxX) / 2;
		yValue = (minY + maxY) / 2;
		
		yse_find_peak_value(field, xValue, yValue, field->FWHM * 2, peakValue);
		
		for(i = 0; i < array_size; i++)
		{
			if(peakValue[0] == array_peak_line[i][0] && peakValue[1] == array_peak_line[i][1])
				addValue = 0;
		}
		
		if(addValue)
		{
			array_peak_line[array_size][0] = peakValue[0];
			array_peak_line[array_size][1] = peakValue[1];
			array_size++;
		}
	}
	
	//peak_line = line3;
	
	line3->x = array_peak_line[0][0];
	line3->y = array_peak_line[0][1];
	
	for(j = 1; j < array_size; j++)
	{
		line3->next = malloc(sizeof(yse_line_list));
		line3 = line3->next;
		
		line3->x = array_peak_line[j][0];
		line3->y = array_peak_line[j][1];
		
		line3->next = NULL;
	}
}
*/

int yse_line_process(yse_field_t *field, yse_line_list *list, yse_star_list *star, int **flag, const char *filename, float *rms, float min_length_streak)
{
	yse_line_list *line;//, *peak_line;
	float x_sum, y_sum;
	float xy_sum, x2_sum, y2_sum;
	int n = 0, drop;
	float x_center, y_center;
	float sx, sy, x0, y0, d, d1, d2;
	int x_max, y_max;
	int x_min, y_min;
	int x_border_max, x_border_min;
	int y_border_max, y_border_min;
	float xf_min, xf_max, yf_min, yf_max;
	float d_max;
	float d_min;
	int swap;
	float dev;
	float ecc;
	static int index;
	int numStar = 0;
	char EXEC[256];
	
	float min_value = 1000., max_value = 0.;
	
	//printf("#line processed...\n");
	x_sum = y_sum = xy_sum = x2_sum = y2_sum = n = drop = 0;
	for (line = list; line != NULL; line = line->next)
	{
		x_sum += line->x;
		y_sum += line->y;
		xy_sum += line->x * line->y;
		x2_sum += line->x * line->x;
		y2_sum += line->y * line->y;
		
		if(min_value > field->data[line->y][line->x])
			min_value = field->data[line->y][line->x];
		
		if(max_value < field->data[line->y][line->x])
			max_value = field->data[line->y][line->x];
		
		n++;
	}
	//printf("%f %f\n", min_value, max_value);
	if (n == 0)
		return 0;
	
	x_center = (float)x_sum / n;
	y_center = (float)y_sum / n;

	sx = (float)(n * xy_sum - x_sum * y_sum) / (float)(n * x2_sum - x_sum * x_sum);
	y0 = (float)(y_sum - sx * x_sum) / (float)(n);
	sy = (float)(n * xy_sum - x_sum * y_sum) / (float)(n * y2_sum - y_sum * y_sum);
	x0 = (float)(x_sum - sy * y_sum) / (float)(n);

	if (fabsf(sx) < 1.)
	{
		dev = sqrt((sx * sx * x2_sum + y2_sum + y0 * y0 * n - 2. * sx * xy_sum + 2. * sx * y0 * x_sum - 2. * y0 * y_sum) / (sx * sx + 1) / n);
	}
	else
	{
		dev = sqrt((sy * sy * y2_sum + x2_sum + n * x0 * x0 - 2. * sy * xy_sum + 2. * sy * x0 * y_sum - 2. * x0 * x_sum) / (sy * sy + 1) / n);
	}

	d_min = d_max = 0.;
	x_min = x_max = x_center;
	y_min = y_max = y_center;
	x_border_max = x_border_min = x_center;
	y_border_max = y_border_min = y_center;
	for (line = list; line != NULL; line = line->next)
	{
		if(line->x > x_border_max)
			x_border_max = line->x;
		if(line->x < x_border_min)
			x_border_min = line->x;
			
		if(line->y > y_border_max)
			y_border_max = line->y;
		if(line->y < y_border_min)
			y_border_min = line->y;
		
		d1 = (line->x - x_center) * (line->x - x_center)
			+ (line->y - y_center) * (line->y - y_center);

		if (fabsf(sx) < 1.)
		{
			d2 = (-sx * line->x + line->y - y0) * (-sx * line->x + line->y - y0)
				/ (sx * sx + 1);
			d = d1 > d2 ? sqrt(d1 - d2) : 0.;
			if (line->x - x_center < 0.)
				d = -d;
		}
		else
		{
			d2 = (line->x - sy * line->y - x0) * (line->x - sy * line->y - x0)
				/ (sy * sy + 1);
			d = d1 > d2 ? sqrt(d1 - d2) : 0.;
			if (line->y - y_center < 0.)
				d = -d;
		}

		if (d > d_max)
		{
			d_max = d;
			x_max = line->x;
			y_max = line->y;
		}
		if (d < d_min)
		{
			d_min = d;
			x_min = line->x;
			y_min = line->y;
		}
	}

	d = d_max - d_min;
	ecc = dev / d;

	//if (d < field->FWHM * 2.)
	//	return 0;
	
	if(dev > 1. && d < 10.)
		return 0;
		
	if(min_length_streak != 0.)
	{
		if (ecc > 0.04)
			return 0;
	}
	else
	{
		if (ecc > 0.2)
			return 0;
	}

	if(ecc < 0)
		return 0;
	
	if (fabsf(sx) < 1.)
	{
		xf_min = d_min / sqrt(1. + sx * sx) + x_center;
		yf_min = sx * xf_min + y0;
		x_min = xf_min;
		y_min = yf_min;
		xf_max = d_max / sqrt(1. + sx * sx) + x_center;
		yf_max = sx * xf_max + y0;
		x_max = xf_max;
		y_max = yf_max;
	}
	else
	{
		yf_min = d_min / sqrt(1. + sy * sy) + y_center;
		xf_min = sy * yf_min + x0;
		y_min = yf_min;
		x_min = xf_min;
		yf_max = d_max / sqrt(1. + sy * sy) + y_center;
		xf_max = sy * yf_max + x0;
		y_max = yf_max;
		x_max = xf_max;
	}

	if (x_min > x_max)
	{
		swap = x_min;
		x_min = x_max;
		x_max = swap;
	}

	if (y_min > y_max)
	{
		swap = y_min;
		y_min = y_max;
		y_max = swap;
	}

	x_max++;
	y_max++;

	if (x_min < 0)
		x_min = 0;
	if (y_min < 0)
		y_min = 0;
	
	numStar = yse_num_sex_star(list, star, x_border_min, y_border_min, x_border_max, y_border_max);
	//if(numStar < 3)
	//	return -1;
	
	if(d < 4.)
		return 0;
	
	if(numStar > 100)
		return 0;
	
	fprintf(stdout, "#INDEX=%d, # of Stars=%d, n=%d/%d/%f, sx=%f, y0=%f, sy=%f, x0=%f dev=%f, ecc=%f, min=(%d, %d):%f, max=(%d, %d):%f, d=%f\n",
	 ++index, numStar, n, n + drop, 100. * n / (n + drop), sx, y0, sy, x0, dev, ecc, x_min, y_min, d_min, x_max, y_max, d_max, d);
	
	sprintf(EXEC, "%s.out.txt", filename);
	
	if(index == 1)
		unlink(EXEC);
		
	FILE *f = fopen(EXEC, "a+");
	
	if(index == 1)
		fprintf(f, "#No xmin ymin xmax ymax   slope  NSTAR dev flat length\n");
	fprintf(f, "%3d %4d %4d %4d %4d %f %4d %f  %f  %f\n", index, x_min, y_min, x_max, y_max, sx, numStar, dev, 1. - ecc, d);
	fclose(f);
	
	sprintf(EXEC, "minmax");
	f = fopen(EXEC, "a+");
	if(index == 1)
		fprintf(f, "#sky rms min max\n");
	fprintf(f, "%f %f %f %f\n", rms[0], rms[1], min_value, max_value);
	fclose(f);
	
	/*
	x_border_min = x_min - 128;
	y_border_min = y_min - 128;
	x_border_max = x_max + 128;
	y_border_max = y_max + 128;
	
	if(x_border_min < 0) x_border_min = 1;
	if(y_border_min < 0) y_border_min = 1;
	if(x_border_max > field->width) x_border_max = field->width;
	if(y_border_max > field->height) y_border_max = field->height;
	
	sprintf(EXEC, "%s %s[%d:%d,%d:%d] %s.out.fits", IMCOPY_EXEC, filename
	, x_border_min, x_border_max, y_border_min, y_border_max, filename);
	system(EXEC);
	
	sprintf(EXEC, "%s -fits %s.out.fits -jpeg %s-%d.jpeg -max %f -min %f", FITS2JPEG_EXEC, filename, filename
	, index, rms[0] + rms[1] * 10., rms[0] - rms[1] * 20.);
	system(EXEC);
	
	sprintf(EXEC, "%s.out.fits", filename);
	unlink(EXEC);
	*/
		
	//fprintf(stdout, " %f %f %f %f\n", xf_min, yf_min, xf_max, yf_max);
	//fprintf(stdout, " IMG=%04d-%04d-%04d-%04d\n", x_min, y_min, x_max, y_max);
	//fprintf(stdout, "#%d %d %d %d\n", x_border_min, y_border_min, x_border_max, y_border_max);
	
	/*
	peak_line = malloc(sizeof(yse_line_list));
	peak_line->next = NULL;
	line = malloc(sizeof(yse_line_list));
	line->next = NULL;
	
	peak_line = line;
	
	yse_peak_line(field, list, sx, line, peak_line);
	yse_line_print(peak_line);
	*/
	
	return 1;
}
